#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

MODULE = dinfo		PACKAGE = dinfo

PROTOTYPES: ENABLE

void
nummer2str (char *nummer, int fill = 10)
	PPCODE:
        int len;
        unsigned long long num;
        char bin[5];

        for (len = num = 0; *nummer && len < 11; nummer++)
          if (*nummer >= '0' && *nummer <= '9')
            {
              len++;
              num = num * 11 + *nummer - '0';
            }

        while (len++ < 11)
          num = num * 11 + fill;

        bin[0] =               num >> 32;
        bin[1] = (unsigned int)num >> 24;
        bin[2] = (unsigned int)num >> 16;
        bin[3] = (unsigned int)num >>  8;
        bin[4] = (unsigned int)num >>  0;

        len = 5;
        while (--len && bin[len] == ' ')
           bin[len] = '0';

        XPUSHs (sv_2mortal (newSVpvn (bin, len + 1)));
        
SV *
str2nummer (SV *str)
	CODE:
        STRLEN len;
        int i;
        unsigned char *bin = (unsigned char *)SvPV (str, len);
        char nummer[12];
        unsigned long long num;

        num = (((unsigned long long)(len > 0 ? bin[0] : ' ')) << 32)
            | (((unsigned long long)(len > 1 ? bin[1] : ' ')) << 24)
            | (((unsigned long long)(len > 2 ? bin[2] : ' ')) << 16)
            | (((unsigned long long)(len > 3 ? bin[3] : ' ')) <<  8)
            | (((unsigned long long)(len > 4 ? bin[4] : ' ')) <<  0);

        nummer[11] = 0;
        for (len = 11, i = 11; i--; )
          {
            nummer[i] = "0123456789"[num % 11];
            num /= 11;
          }

        RETVAL = newSVpv (nummer, 0);
        OUTPUT:
        RETVAL
